Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 691708 - net-dns/bind-tools-9.14.4: Error: Architecture mismatch on "pause ". (Requires v9e|v9v|v9m|m8; requested architecture is v9b.)
Summary: net-dns/bind-tools-9.14.4: Error: Architecture mismatch on "pause ". (Require...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: Sparc64 Linux
: Normal normal (vote)
Assignee: Christian Ruppert (idl0r)
URL: https://gitlab.isc.org/isc-projects/b...
Whiteboard:
Keywords: PATCH
Depends on:
Blocks:
 
Reported: 2019-08-07 18:24 UTC by Rolf Eike Beer
Modified: 2019-08-22 11:10 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (build.log,100.57 KB, text/x-log)
2019-08-07 18:24 UTC, Rolf Eike Beer
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Rolf Eike Beer 2019-08-07 18:24:39 UTC
Created attachment 586068 [details]
build.log

{standard input}: Assembler messages:
{standard input}:398: Error: Architecture mismatch on "pause ".
{standard input}:398: (Requires v9e|v9v|v9m|m8; requested architecture is v9b.)

Portage 2.3.69 (python 3.6.5-final-0, default/linux/sparc/17.0, gcc-8.3.0, glibc-2.29-r2, 5.2.5 sparc64)
=================================================================
System uname: Linux-5.2.5-sparc64-sun4v-with-gentoo-2.4.1
KiB Mem:    33129592 total,   7074904 free
KiB Swap:          0 total,         0 free
Timestamp of repository gentoo: Wed, 07 Aug 2019 00:15:01 +0000
sh bash 4.4_p23-r1
ld GNU ld (Gentoo 2.32 p2) 2.32.0
ccache version 3.7.1 [disabled]
app-shells/bash:          4.4_p23-r1::gentoo
dev-lang/perl:            5.26.2::gentoo
dev-lang/python:          2.7.15::gentoo, 3.6.5::gentoo
dev-util/ccache:          3.7.1::gentoo
dev-util/cmake:           3.14.6::gentoo
sys-apps/baselayout:      2.4.1-r2::gentoo
sys-apps/openrc:          0.38.3-r1::gentoo
sys-apps/sandbox:         2.13::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.11.6-r3::gentoo, 1.13.4-r2::gentoo, 1.16.1-r1::gentoo
sys-devel/binutils:       2.32-r1::gentoo
sys-devel/gcc:            8.3.0-r1::gentoo
sys-devel/gcc-config:     2.0::gentoo
sys-devel/libtool:        2.4.6-r3::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 4.19::gentoo (virtual/os-headers)
sys-libs/glibc:           2.29-r2::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: git
    sync-uri: https://anongit.gentoo.org/git/repo/sync/gentoo.git
    priority: -1000
    sync-git-verify-commit-signature: yes

ACCEPT_KEYWORDS="sparc"
ACCEPT_LICENSE="* -@EULA"
CBUILD="sparc-unknown-linux-gnu"
CFLAGS="-O2 -mcpu=niagara2 -pipe -Wcast-align"
CHOST="sparc-unknown-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.6/ext-active/ /etc/php/apache2-php7.1/ext-active/ /etc/php/apache2-php7.2/ext-active/ /etc/php/apache2-php7.3/ext-active/ /etc/php/cgi-php5.6/ext-active/ /etc/php/cgi-php7.1/ext-active/ /etc/php/cgi-php7.2/ext-active/ /etc/php/cgi-php7.3/ext-active/ /etc/php/cli-php5.6/ext-active/ /etc/php/cli-php7.1/ext-active/ /etc/php/cli-php7.2/ext-active/ /etc/php/cli-php7.3/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -mcpu=niagara2 -pipe -Wcast-align"
DISTDIR="/usr/portage/distfiles"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS=""
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned sandbox sfperms strict strict-keepdir unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS=""
GENTOO_MIRRORS="ftp://ftp.wh2.tu-dresden.de/pub/mirrors/gentoo ftp://ftp.join.uni-muenster.de/pub/linux/distributions/gentoo"
LANG="en_US.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j20 -l40"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="acl berkdb big-endian bzip2 cli crypt cxx dri fortran gdbm iconv ipv6 libtirpc ncurses nls nptl openmp pam pcre readline sparc split-usr ssl tcpd unicode xattr zlib" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="libinput keyboard mouse" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" NETBEANS_MODULES="apisupport cnd groovy gsf harness ide identity j2ee java mobility nb php profiler soa visualweb webcommon websvccommon xml" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-2" POSTGRES_TARGETS="postgres10 postgres11" PYTHON_SINGLE_TARGET="python3_6" PYTHON_TARGETS="python2_7 python3_6" RUBY_TARGETS="ruby24" USERLAND="GNU" VIDEO_CARDS="fbdev glint mga r128 radeon dummy v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, LINGUAS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

I have also tried with glibc 2.28, fails the same.
Comment 1 Sergei Trofimovich gentoo-dev 2019-08-07 23:02:14 UTC
Posting the find on #gentoo-sparc here:

The error is:

{standard input}: Assembler messages:
{standard input}:11: Error: Architecture mismatch on "pause ".
{standard input}:11: (Requires v9e|v9v|v9m|m8; requested architecture is v9b.)

23:41:28 <@slyfox> bind's rwlock uses "pause" instruction.
23:42:04 <@slyfox> lib/isc/rwlock.c-#elif defined(__sparc) || defined(__sparc__)
23:42:05 <@slyfox> lib/isc/rwlock.c:# define isc_rwlock_pause() __asm__ __volatile__ ("pause")
23:42:40 <@slyfox> i think it needs an extra guard for the v9b ISA
23:42:51 <@slyfox> and fallback to 'lib/isc/rwlock.c-# define isc_rwlock_pause()' busy loop
23:44:01 <@slyfox> https://gitlab.isc.org/isc-projects/bind9/issues/816
23:47:50 <@mattst88> yeah, looks like pause is only on T4 and later CPUs
Comment 2 Sergei Trofimovich gentoo-dev 2019-08-07 23:07:29 UTC
-mcpu=niagara4 or upper would work but unfortunately gcc does not export any defines to make a distinction:

$ cat bug.c
a() { __asm__("pause"); }

$ sparc-unknown-linux-gnu-gcc -mcpu=niagara3 -c bug.c
bug.c:1:1: warning: return type defaults to 'int' [-Wimplicit-int]
    1 | a() { __asm__("pause"); }
      | ^
/tmp/cc0FYKQS.s: Assembler messages:
/tmp/cc0FYKQS.s:11: Error: Architecture mismatch on "pause ".
/tmp/cc0FYKQS.s:11: (Requires v9e|v9v|v9m|m8; requested architecture is v9d.)

$ sparc-unknown-linux-gnu-gcc -mcpu=niagara4 -c bug.c
bug.c:1:1: warning: return type defaults to 'int' [-Wimplicit-int]
    1 | a() { __asm__("pause"); }
      | ^


$ diff -U0 <(sparc-unknown-linux-gnu-gcc -O2 -mcpu=niagara3 -dM -E - </dev/null) <(sparc-unknown-linux-gnu-gcc -O2 -mcpu=niagara4 -dM -E - </dev/null)
Comment 3 Sergei Trofimovich gentoo-dev 2019-08-08 08:46:32 UTC
Proposed https://gitlab.isc.org/isc-projects/bind9/merge_requests/2243 upstream.
Comment 4 Rolf Eike Beer 2019-08-19 17:05:41 UTC
Ping? I can't build the only secure version now.
Comment 5 Larry the Git Cow gentoo-dev 2019-08-22 11:10:06 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=25be2b1ffdcbf50bf28d89f8987f853f9bdca79c

commit 25be2b1ffdcbf50bf28d89f8987f853f9bdca79c
Author:     Mikle Kolyada <zlogene@gentoo.org>
AuthorDate: 2019-08-22 11:09:27 +0000
Commit:     Mikle Kolyada <zlogene@gentoo.org>
CommitDate: 2019-08-22 11:10:02 +0000

    net-dns/bind-tools: detect sparc pause instruction properly
    
    Closes: https://bugs.gentoo.org/691708
    Package-Manager: Portage-2.3.69, Repoman-2.3.16
    Signed-off-by: Mikle Kolyada <zlogene@gentoo.org>

 net-dns/bind-tools/bind-tools-9.14.4.ebuild        |   2 +
 .../bind-tools/files/sparc-pause-instruction.patch | 135 +++++++++++++++++++++
 2 files changed, 137 insertions(+)